Unit BasConv;

Interface

Function Bas2Long(InValue: LongInt): LongInt;
         {Convert Basic Short Reals to LongInts}

Function Long2Bas(InValue: LongInt): LongInt;
         {Convert LongInts to Basic Short Reals}

Implementation

Function Bas2Long(InValue: LongInt): LongInt;
Var
  Temp  : LongInt;
  Expon : Integer;
Begin
  Expon := ((InValue shr 24) and $ff) - 152;
  Temp := (InValue and $007FFFFF) or $00800000;
  If Expon < 0 Then Temp := Temp shr Abs(Expon)
  Else Temp := Temp shl Expon;
  If (InValue and $00800000) <> 0 Then Bas2Long := -Temp
  Else Bas2Long := Temp;
  If Expon = 0 Then Bas2Long := 0;
End;

Function Long2Bas(InValue: LongInt): LongInt;
Var
  Negative : Boolean;
  Expon    : LongInt;
Begin
  If InValue = 0 Then Long2Bas := 0
  Else Begin
    If InValue < 0 Then Begin
      Negative := True;
      InValue := Abs(InValue);
    End Else Negative := False;
    Expon := 152;
    If InValue < $007FFFFF Then
      While ((InValue and $00800000) = 0) Do Begin
        InValue := InValue shl 1;
        Dec(Expon);
      End
    Else While ((InValue And $FF000000) <> 0) Do Begin
      InValue := InValue shr 1;
      Inc(Expon);
    End;
    InValue := InValue And $007FFFFF;
    If Negative Then InValue := InValue Or $00800000;
    Long2Bas := InValue + (Expon shl 24);
  End;
End;

End.
